# Compiling MASQ Node

To compile MASQ Node from source on GitHub here is a basic guide for Ubuntu, using `rustup` to install rustc

## System Update

```
$ sudo apt update
$ sudo apt upgrade
$ sudo reboot now
```

## Install Compilation Dependency

### Development tools

```
$ sudo apt install curl git build-essential
```

### Rust

```bash
$ curl --proto =https --tlsv1.2 -sSf https://sh.rustup.rs | sh
When see "1) Proceed with installation (default)", press "ENTER" key to choose the default option.
$ source $HOME/.cargo/env
```

## Compile MASQNode CLI

Download MASQNode source code

```
$ git clone https://github.com/MASQ-Project/Node.git node_src
```

Compile

```
$ node_src/node/ci/build.sh $ node_src/dns_utility/ci/build.sh
```

## Install MASQNode

Copy compiled binaries to `/.local/bin`

```
$ mkdir -p .local/bin
$ cp node_src/node/target/release/masq .local/bin/
$ cp node_src/node/target/release/MASQNode .local/bin/
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.masqbrowser.com/masq/advanced-use/compiling-masq-node.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
